// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#pragma once


// CSetFloatValueDialog dialog

class CSetFloatValueDialog : public CDialog
{
	DECLARE_DYNAMIC(CSetFloatValueDialog)

public:
	CSetFloatValueDialog(float fMinValue, 
						 float fMaxValue, 
						 float fCurrent,
						 const char * pName = "Value",
						 bool bInteger = false,
						 CWnd* pParent = NULL);   // standard constructor
	virtual ~CSetFloatValueDialog();

// Dialog Data
	enum { IDD = IDD_SETFLOATVALUE_DIALOG };

	float GetNewValue() { return m_fNewValueFloat; }
	int GetNewValueInteger() { return m_fNewValueInt; }

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	float m_fMinValue;
	float m_fMaxValue;
	float m_fCurrentValue;
	const char * m_pName;
	bool m_bInteger;

	float m_fNewValueFloat;
	int m_fNewValueInt;

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
	virtual BOOL OnInitDialog();
};
