// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#include "StdAfx.h"
#include ".\systemconstants.h"
#include <fstream>

CSystemConstants::CSystemConstants(void)
{
}

CSystemConstants::~CSystemConstants(void)
{
}


CString CSystemConstants::GetBasePath()
{
	static CString * s_pBasePath = NULL;
	if ( s_pBasePath == NULL ) {
		s_pBasePath = new CString("");

		// check if there is a srcroot.txt file that we should read the basepath from
		std::ifstream in( "srcroot.txt" );
		if ( in ) {
			char buf[1024];
			in >> buf;
			if ( in ) {
				*s_pBasePath = CString(buf);

				// make sure path is terminated w/ backslash
				if ( s_pBasePath->GetAt( s_pBasePath->GetLength() - 1 ) != '\\' )
					s_pBasePath->AppendChar('\\');
				in.close();
			}
		}
	}
	return *s_pBasePath;
}


CString CSystemConstants::GetIconPath()
{
	return GetBasePath() + CString("icons\\");
}

CString CSystemConstants::GetAnimationPath()
{
	return GetBasePath() + CString("animations\\");
}



bool CSystemConstants::IsDevelBuild()
{
	const static unsigned int nDevelCode = 31393131;
	static int nDevelBuild = -1;

	if ( nDevelBuild == -1 ) {
		nDevelBuild = 0;

		// try to open devel code file
		std::ifstream in( "devbuild.txt" );
		if ( in ) {
			unsigned int nCode;
			in >> nCode;
			if ( nCode == nDevelCode )
				nDevelBuild = 1;
			in.close();
		}
	}
	return (nDevelBuild == 1);
}