// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef RMS_TRIANGLE_MESH_RENDERER
#define RMS_TRIANGLE_MESH_RENDERER

#include <TriangleMesh.h>
#include <ScalarField.h>

class TriangleMeshRenderer
{
public:
	TriangleMeshRenderer( rmsimplicit::TriangleMesh * pMesh )
		: m_pMesh(pMesh)
	{
	}

	void DrawAsZFill();

	void DrawImmediateVtxNormal() const;
	void DrawImmediateVtxNormalAndColor() const;
	void DrawImmediateVtxNormalAndTex(bool bPerVtxTexCoords) const;

	void DrawImmediateTriNormal() const;
	void DrawImmediateTriNormalAndColor() const;
	void DrawImmediateTriNormalAndTex(bool bPerVtxTexCoords) const;

	void DrawImmediate( bool bUseTriNormals, bool bUseMeshColor, bool bOutputTexCoords, bool bPerVtxTexCoords ) const;

	void DrawImmediate(bool bUseTriNormals = false) const;
	void DrawImmediateWithColor(bool bUseTriNormals = false) const;

	void DrawVertexBuffer() const;

	void DrawNormals( float fLength = 1.0 ) const;

	void DrawVerticesAsPoints() const;

	void DrawCameraProjection( float fLength, const Wml::Vector3f & vCameraPos ) const;
	void DrawCurvatureDirections( float fLength, bool bFirst, bool bSecond, rmsimplicit::ScalarField * pField ) const;

protected:
	rmsimplicit::TriangleMesh * m_pMesh;
};


#endif  // RMS_TRIANGLE_MESH_RENDERER