// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#include "StdAfx.h"
#include "GLUtil.h"

#include <gl/GL.h>
#include <gl/GLU.h>

using namespace rmsui;


void GLUtil::MakeGLLookAtMatrix( const Wml::Vector3f & vLookAt,
								 const Wml::Vector3f & vUp,
								 const Wml::Vector3f & vSide,
								 float glMatrix[4][4] )
{
	memset(&glMatrix[0][0], 0, sizeof(float)*16);
	glMatrix[3][3] = 1.0;
	glMatrix[0][0] = vSide.X();
	glMatrix[1][0] = vSide.Y();
	glMatrix[2][0] = vSide.Z();

	glMatrix[0][1] = vUp.X();  
	glMatrix[1][1] = vUp.Y();  
	glMatrix[2][1] = vUp.Z();

	glMatrix[0][2] = -vLookAt.X();  
	glMatrix[1][2] = -vLookAt.Y();  
	glMatrix[2][2] = -vLookAt.Z();
}