// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef _RMSUI_HUD_BUTTON_H_
#define _RMSUI_HUD_BUTTON_H_

#include "HUDItem.h"
#include "HUDImage.h"


namespace rmsui
{

class HUDButtonEventHandler : public HUDEventHandler
{
public:
	virtual ~HUDButtonEventHandler() {}

	// events
	virtual void OnCross() {}

	virtual void OnDragStart( const Wml::Vector2f & vStartPos ) {}
	virtual void OnDragDelta( const Wml::Vector2f & vDelta ) {}
	virtual void OnDragEnd( const Wml::Vector2f & vEndPos ) {}
};


class HUDButton : public HUDItem
{
public:
	HUDButton(const std::string & name, HUDIcon * pIcon, bool bSendCaptureEvents = false, bool bSendCrossEvents = false);
	virtual ~HUDButton();

	virtual HUDItem * BeginConsume( const Wml::Vector2f & vPoint );
	virtual HUDItem * Consume( const Wml::Vector2f & vNextPoint );
	virtual void EndConsume();

	virtual HUDItem * TestLineStroke( const GestureLineStroke & stroke );

	/*
	 * overrides
	 */
	virtual void Render();

protected:
	bool m_bCapturingEnabled;
	bool m_bCrossingEnabled;

	HUDIcon * m_pIcon;

	bool m_bConsuming;
	Wml::Vector2f m_vLastPoint;

	void NotifyCross();
	void NotifyDragStart( const Wml::Vector2f & vStart );
	void NotifyDragDelta( const Wml::Vector2f & vDelta );
	void NotifyDragEnd( const Wml::Vector2f & vEnd );

};



}   // namespace rmsui



#endif // _RMSUI_HUD_BUTTON_H_