// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#include "StdAfx.h"
#include "Timer.h"

using namespace rmsui;


TimeEvent::TimeEvent()
{
	QueryPerformanceCounter(&m_time);
}


TimeEvent TimeEvent::Now()
{
	return TimeEvent();
}

//! returns time delta fabsf(now - since)
float TimeEvent::SecondsDelta( const TimeEvent & time2 ) const
{
	LARGE_INTEGER freq;
	QueryPerformanceFrequency(&freq);
	return (float)( (double)( (m_time.QuadPart - time2.m_time.QuadPart)) / (double)freq.QuadPart);
}



bool TimeEventGenerator::Tick()
{
	std::set<ITimeEventListener *>::iterator cur(m_vListeners.begin()), end(m_vListeners.end());
	TimeEvent now;
	bool bGotTrue = false;
	while ( cur != end ) {
		bGotTrue = bGotTrue || (*cur++)->OnTimeEvent( now );
	}
	return bGotTrue;
}