// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef __WMLEXT_INTERPOLATING_SPLINE_2D_H__
#define __WMLEXT_INTERPOLATING_SPLINE_2D_H__

#include "WmlExt.h"

#include <WmlVector2.h>
#include <vector>

namespace Wml
{

template<class Real>
class WMLEXT_ITEM InterpolatingSpline2
{
public:
	InterpolatingSpline2();
	InterpolatingSpline2(const std::vector<Wml::Vector2<Real> > & vControlPoints);

	Wml::Vector2<Real> GetPosition( Real fT );

protected:

	std::vector<Wml::Vector2<Real> > m_vControlPoints;
};

typedef InterpolatingSpline2<float> InterpolatingSpline2f;
typedef InterpolatingSpline2<double> InterpolatingSpline2d;


}	// namespace Wml



#endif	// __WMLEXT_INTERPOLATING_SPLINE_2D_H__