// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef __RMS_WMLEXT_WMLPOLYNOMIALROOTSEXT_H__
#define __RMS_WMLEXT_WMLPOLYNOMIALROOTSEXT_H__

#include "WmlExt.h"

#include <WmlPolynomial1.h>
#include <WmlGMatrix.h>

#include <vector>

namespace Wml
{

template <class Real>
class WMLEXT_ITEM PolynomialRootsExt
{
public:

	//! mHessenberg will be initialized by function
	static void MakeHessenbergMatrix( Wml::Polynomial1<Real> & Poly, Wml::GMatrix<Real>& mHessenberg );

	//! pRoots must be large enough to hold all roots (max = degree of poly). nCount will return # of roots found
	static bool EigenRoots( Wml::Polynomial1<Real> & Poly, Real * pRoots, int & nCount );

protected:

};


typedef PolynomialRootsExt<double> PolynomialRootsExtd;
typedef PolynomialRootsExt<float> PolynomialRootsExtf;

} // namespace Wml


#endif // __RMS_WMLEXT_WMLPOLYNOMIALROOTSEXT_H__